import java.rmi.*;
import java.io.*;
import javax.naming.*;
import java.rmi.RMISecurityManager;
import javax.rmi.PortableRemoteObject;
import java.util.*;

import javax.rmi.PortableRemoteObject;
import java.rmi.server.*;
import java.rmi.*;
import java.util.*;
import javax.naming.*;

import javax.naming.InitialContext;
import javax.naming.Context;
import com.sun.corba.se.internal.POA.POAORB;
import org.omg.PortableServer.*;
import org.omg.CORBA.*;
import javax.rmi.CORBA.Stub;
import javax.rmi.CORBA.Util;

public class ChatClient {

	public static void main(String[] args) {
		BufferedReader console = new BufferedReader(new InputStreamReader(System.in));
		
		try {
			Context ic;
			java.lang.Object objref = null;
			IChatServer server;
			
			Hashtable props = new Hashtable();				
			props.put("java.naming.factory.initial", "com.sun.jndi.cosnaming.CNCtxFactory");
			// Indiquem a on esta escoltant el naming service
			props.put("java.naming.provider.url", "iiop://localhost:900");
			ic = new InitialContext(props);
			
			// Obtenir la referencia a l'objecte usant el name service amb una crida JNDI
			objref = ic.lookup("Xat");
			System.out.println("Referencia obtinguda.");
	
			// Convertir la referencia al objecte (narrow)
			server = (IChatServer)PortableRemoteObject.narrow(objref, IChatServer.class);
			
			/////////////////
			// Exportem un objecte control el qual ser accedit des del servidor
			Properties p = System.getProperties();
			p.put("org.omg.CORBA.ORBClass", "com.sun.corba.se.internal.POA.POAORB");
			p.put("org.omg.CORBA.ORBSingletonClass", "com.sun.corba.se.internal.corba.ORBSingleton");

			ORB orb = ORB.init( args, p );
			POA rootPOA = (POA)orb.resolve_initial_references("RootPOA");

			// Creem POA amb la seva poltica
			Policy[] tpolicy = new Policy[3];
			// Transient: L'objecte noms existeix mentre estigui instanciat (no es permanent)
			tpolicy[0] = rootPOA.create_lifespan_policy(LifespanPolicyValue.TRANSIENT );
			// Si no existeix l'ID de l'objecte al Active Object Map. => Es produeix excepci 
			// (no hi ha servei per defecte ni es dona cap oportunitat al gestor de serveis de
			// trobar un altre)
			tpolicy[1] = rootPOA.create_request_processing_policy(RequestProcessingPolicyValue.USE_ACTIVE_OBJECT_MAP_ONLY );
			// POA guarda els serveis actius al Active Object Map.
			tpolicy[2] = rootPOA.create_servant_retention_policy(ServantRetentionPolicyValue.RETAIN);
			
			POA tPOA = rootPOA.create_POA("MyTransientPOA2", null, tpolicy);
          
			// Activem el gestor POA
			tPOA.the_POAManager().activate();
         			
			// Instaciem el control i activem el Tie (delegaci o tie model)
			System.out.print("Nick: ");
			String nick = console.readLine();
			Control ctrl_orig = new Control(nick);
			
			_Control_Tie tie = (_Control_Tie)Util.getTie( ctrl_orig );
			String nomId = "Control";
			byte[] id = nomId.getBytes();
			tPOA.activate_object_with_id( id, tie );
			
			// Obtenim la referencia al objecte control exportat
			objref = tPOA.create_reference_with_id(id, tie._all_interfaces(tPOA,id)[0]);
			IControl ctrl = (IControl)PortableRemoteObject.narrow(objref, IControl.class);
			/////////////////

			// Ens connectem al servidor indicant la referencia al objecte control
			server.Connectar(ctrl);
			String text = console.readLine();
			while (text.compareTo("/quit") != 0) {
				if (text.compareTo("/users") == 0) {
					String userList[] = server.usuaris();
					System.out.println("-- Users --");
					for (int i=0; i<userList.length; i++) {
						System.out.println(userList[i]);
					}
					System.out.println("-- End --");
				} else {
					server.Enviar(ctrl, text);
				}
				text = console.readLine();
			}
			
			System.out.println("Exiting...");
			server.Desconnectar(ctrl);
		} catch (Exception e) {
			e.printStackTrace(); 
		}
	}
}
