import javax.rmi.PortableRemoteObject;
import java.rmi.server.*;
import java.rmi.*;
import java.util.*;
import javax.naming.*;

import javax.naming.InitialContext;
import javax.naming.Context;
import com.sun.corba.se.internal.POA.POAORB;
import org.omg.PortableServer.*;
import org.omg.CORBA.*;
import javax.rmi.CORBA.Stub;
import javax.rmi.CORBA.Util;


public class RunServer {
	public static void main(String[] args) {
		try {
			
			Properties p = System.getProperties();
			p.put("org.omg.CORBA.ORBClass", "com.sun.corba.se.internal.POA.POAORB");
			p.put("org.omg.CORBA.ORBSingletonClass", "com.sun.corba.se.internal.corba.ORBSingleton");

			ORB orb = ORB.init( args, p );

			POA rootPOA = (POA)orb.resolve_initial_references("RootPOA");

			// Creem POA amb la seva poltica
			
			Policy[] tpolicy = new Policy[3];
			// Transient: L'objecte noms existeix mentre estigui instanciat (no es permanent)
			tpolicy[0] = rootPOA.create_lifespan_policy(LifespanPolicyValue.TRANSIENT );
			// Si no existeix l'ID de l'objecte al Active Object Map. => Es produeix excepci 
			// (no hi ha servei per defecte ni es dona cap oportunitat al gestor de serveis de
			// trobar un altre)
			tpolicy[1] = rootPOA.create_request_processing_policy(RequestProcessingPolicyValue.USE_ACTIVE_OBJECT_MAP_ONLY );
			// POA guarda els serveis actius al Active Object Map.
			tpolicy[2] = rootPOA.create_servant_retention_policy(ServantRetentionPolicyValue.RETAIN);
			
			POA tPOA = rootPOA.create_POA("MyTransientPOA", null, tpolicy);
          
			// Activem el gestor POA
			tPOA.the_POAManager().activate();

			// Instaciem el servei de Xat i activem el Tie (delegaci o tie model)
			ChatServer server = new ChatServer();
			_ChatServer_Tie tie = (_ChatServer_Tie)Util.getTie( server );
			String nomId = "Xat";
			byte[] id = nomId.getBytes();
			tPOA.activate_object_with_id( id, tie );

			// Publicaci de la referencia del objecte utilitzant el mateix objecte
			// usat per activar el Tie object.
			Hashtable props = new Hashtable();
			props.put("java.naming.factory.initial", "com.sun.jndi.cosnaming.CNCtxFactory");
			// Indiquem a on esta escoltant el naming service
			props.put("java.naming.provider.url", "iiop://localhost:900");
			Context initialNamingContext = new InitialContext(props);
			initialNamingContext.rebind("Xat", tPOA.create_reference_with_id(id, tie._all_interfaces(tPOA,id)[0]) );
			System.out.println("Ready...");
			
			// Acceptem clients
			orb.run();
			
			/*Hashtable props = new Hashtable();
			props.put("java.naming.factory.initial", "com.sun.jndi.cosnaming.CNCtxFactory");
			// Indiquem a on esta escoltant el naming service
			props.put("java.naming.provider.url", "iiop://localhost:900");
			Context ctx = new InitialContext(props);
			
			// Registrem el servidor xat al naming service de CORBA
			ctx.rebind("Xat", server);
			System.out.println("Registered.");*/
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
