import java.rmi.*;
import java.io.*;
import javax.naming.*;
import java.rmi.RMISecurityManager;
import javax.rmi.PortableRemoteObject;
import java.util.*;

public class ChatClient {

	public static void main(String[] args) {
		BufferedReader console = new BufferedReader(new InputStreamReader(System.in));
		
		try {
			Hashtable props = new Hashtable();
			props.put("java.naming.factory.initial", "com.sun.jndi.cosnaming.CNCtxFactory");
			// Indiquem a on esta escoltant el naming service
			props.put("java.naming.provider.url", "iiop://localhost:900");
			Context ctx = new InitialContext(props);
			
			IChatServer server = (IChatServer)PortableRemoteObject.narrow(ctx.lookup("Xat"), IChatServer.class);
			
			System.out.println ("Receiving proxy...");
			
			System.out.print("Nick: ");
			String nick = console.readLine();
			Control ctrl = new Control(nick);
			server.Connectar(ctrl);
			
			String text = console.readLine();
			while (text.compareTo("/quit") != 0) {
				if (text.compareTo("/users") == 0) {
					String userList[] = server.usuaris();
					System.out.println("-- Users --");
					for (int i=0; i<userList.length; i++) {
						System.out.println(userList[i]);
					}
					System.out.println("-- End --");
				} else {
					server.Enviar(ctrl, text);
				}
				text = console.readLine();
			}
			
			System.out.println("Exiting...");
			server.Desconnectar(ctrl);
		} catch (Exception e) {
			e.printStackTrace(); 
		}
	}
}
