import javax.rmi.PortableRemoteObject;
import java.rmi.server.*;
import java.rmi.*;
import java.util.*;
import javax.naming.*;

public class ChatServer extends PortableRemoteObject implements IChatServer {
	Vector users = new Vector();
	
	public ChatServer() throws RemoteException {
		super();
	}

	public void Connectar(IControl ctrl) {
		users.add(ctrl);
	}

	public void Desconnectar(IControl ctrl) {
		users.remove(ctrl);
	}

	public String[] usuaris() {
		String[] result = new String[users.size()];
		int i = 0;
		
		Iterator it = users.iterator();
		while (it.hasNext()) {
			IControl ctrlElement = (IControl)it.next();
			try {
				String id = ctrlElement.getID();
				result[i] = id;
				i++;
			} catch (RemoteException e){
				users.remove(ctrlElement);
				System.out.println("Cleaned!");
			}
		}

		return result;
	}

	public void Enviar(IControl ctrl, String missatge) {
		IControl ctrlElement;
		
		Iterator it = users.iterator();
		while (it.hasNext()) {
			ctrlElement = (IControl)it.next();
			try {
				ctrlElement.Talk(ctrl.getID(), missatge);
			} catch (RemoteException e) {
				// User not online
				users.remove(ctrlElement);
				System.out.println("Cleaned!");
				//e.printStackTrace();
			}
		}
	}

	public static void main(String[] args) {
		try {
			ChatServer server = new ChatServer();
			
			Hashtable props = new Hashtable();
			props.put("java.naming.factory.initial", "com.sun.jndi.cosnaming.CNCtxFactory");
			// Indiquem a on esta escoltant el naming service
			props.put("java.naming.provider.url", "iiop://localhost:900");
			Context ctx = new InitialContext(props);
			
			// Registrem el servidor xat al naming service de CORBA
			ctx.rebind("Xat", server);
			System.out.println("Registered.");
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
